<?php defined('SYSPATH') or die('No direct script access.');

/**
 * @property-read $ID int
 */
class Model_Faculty extends Model
{
    private $ID;

    public function __get($name) {
        if ($name === 'ID')
            return $this->ID;
        throw new RuntimeException();
    }

    public static function with($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('ID is incorrect!');

        $f = new self();
        $f->ID = (int) $id;
        return $f;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;
        $sql = "CALL `GetDisciplines`(:id, :semesterID)";
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->ID)
            ->param(':semesterID', $semesterID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true);

        return $list;
    }

    /**
     * Pass groupID == 0 & gradeID == 0 to get all students.
     */
    public function getStudents($gradeID = null, $groupID = null, $semesterID = null) {
        $semesterID = $semesterID ? $semesterID : User::instance()->SemesterID;

        $sql = 'CALL `GetStudentsByFaculty`(:faculty, :grade, :group, :semester)';
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty'  => (int) $this->ID,
                ':grade'    => (int) $gradeID,
                ':group'    => (int) $groupID,
                ':semester' => (int) $semesterID,
            ])->execute()->as_array();
    }

    public function getGroups($grade) {
        $sql = "CALL `GetGroups`(:grade, :id)";
        return DB::query(Database::SELECT, $sql)
            ->param(':grade', (int) $grade)
            ->param(':id', $this->ID)
            ->execute()->as_array();
    }

    public function getSubjects() {
        $sql = "CALL `GetSubjects`(:faculty)";
        return DB::query(Database::SELECT, $sql)
            ->param(':faculty', $this->ID)
            ->execute()->as_array();
    }
}
